SystemOrganization addCategory: #ConfigurationOfHoneyGinger!

Object subclass: #ConfigurationOfHoneyGinger
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfHoneyGinger'!

!ConfigurationOfHoneyGinger class methodsFor: 'development support' stamp: 'tomooda 5/18/2015 01:42'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfHoneyGinger class methodsFor: 'private' stamp: 'tomooda 5/18/2015 01:42'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfHoneyGinger class methodsFor: 'private' stamp: 'tomooda 5/18/2015 01:42'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfHoneyGinger class methodsFor: 'private' stamp: 'tomooda 5/18/2015 01:42'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfHoneyGinger class methodsFor: 'metacello tool support' stamp: 'tomooda 5/18/2015 01:42'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfHoneyGinger class methodsFor: 'loading' stamp: 'tomooda 5/18/2015 01:42'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfHoneyGinger class methodsFor: 'loading' stamp: 'tomooda 5/18/2015 01:42'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfHoneyGinger class methodsFor: 'loading' stamp: 'tomooda 5/18/2015 01:42'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfHoneyGinger class methodsFor: 'accessing' stamp: 'tomooda 5/18/2015 01:42'!
project

	^self new project! !

!ConfigurationOfHoneyGinger class methodsFor: 'development support' stamp: 'tomooda 5/18/2015 01:42'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfHoneyGinger methodsFor: 'baselines' stamp: 'tomooda 5/18/2015 02:10'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/tomooda/HoneyGinger/main'.
		spec package: 'HoneyGinger'. ].
! !

!ConfigurationOfHoneyGinger methodsFor: 'accessing' stamp: 'tomooda 5/18/2015 01:41'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfHoneyGinger methodsFor: 'symbolic versions' stamp: 'tomooda 5/18/2015 02:10'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfHoneyGinger methodsFor: 'accessing' stamp: 'tomooda 5/18/2015 01:41'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfHoneyGinger methodsFor: 'symbolic versions' stamp: 'tomooda 5/28/2015 16:09'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.2'.
! !

!ConfigurationOfHoneyGinger methodsFor: 'versions' stamp: 'tomooda 5/18/2015 02:10'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'tomooda'.
		spec timestamp: '5/18/2015 02:10'.
		spec package: 'HoneyGinger' with: 'HoneyGinger-tomooda.139'. ].
! !

!ConfigurationOfHoneyGinger methodsFor: 'versions' stamp: 'tomooda 5/18/2015 02:54'!
version11: spec
	<version: '1.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.1'.
		spec author: 'tomooda'.
		spec timestamp: '5/18/2015 02:54'.
		spec package: 'HoneyGinger' with: 'HoneyGinger-tomooda.140'. ].
! !

!ConfigurationOfHoneyGinger methodsFor: 'versions' stamp: 'tomooda 5/28/2015 16:09'!
version12: spec
	<version: '1.2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.2'.
		spec author: 'tomooda'.
		spec timestamp: '5/28/2015 16:09'.
		spec package: 'HoneyGinger' with: 'HoneyGinger-tomooda.141'. ].
! !
